/******************************************************************************

Copyright (c) 2007   Tsunehiko Kato

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\tgEF
Avj̕擾邷ׂĂ̐lɑ΂A\tgEFA𖳐ɈƂ𖳏ŋ
܂Bɂ́A\tgEFA̕gpAʁAύXAAfځAЕzATu
CZXA/܂͔̔錠Aу\tgEFA񋟂鑊ɓ
Ƃ錠Ɋ܂܂܂B

L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dvȕ
Lڂ̂Ƃ܂B

\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ؂
񋟂܂Błۏ؂Ƃ́AiA̖ړIւ̓KAьN
QɂĂ̕ۏ؂܂݂܂AɌ肳̂ł͂܂B ҂܂͒
쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\tgEFAɋN܂
֘AA邢̓\tgEFA̎gp܂͂̑̈ɂĐ؂̐A
QȂ̋`ɂĉ̐ӔCȂ̂Ƃ܂B
*******************************************************************************/
#include  <windows.h>
#include  "cpu.h"



cpu_info
get_cpu_info()
{
	cpu_info ci;
	memset(&ci, 0, sizeof(ci));


	//------------------------------------------
	//  Checking for CPUID instruction support
	//------------------------------------------
	__try {
		_asm {
			mov	eax, 00H
			cpuid
		}
	}

	__except(1) {
		return ci;
	}

	ci.bCPUID = true;


	//-----------------------------
	//  Checking for SIMD support
	//-----------------------------
	int flg;

	_asm {
		mov eax, 1			; request for feature flags
		cpuid				; 0Fh, 0A2h cpuid instruction
		mov flg, edx
	}


	//---  MMX  ---
	ci.bMMX = (flg & 0x800000);


	//---  SSE  ---
	if (flg & 0x2000000) {
		ci.bSSE = true;

		// OS support check
		__try {
			__asm	xorps xmm0, xmm0
		}

		__except (EXCEPTION_EXECUTE_HANDLER) {
			if (_exception_code() == STATUS_ILLEGAL_INSTRUCTION) {
				ci.bSSE = false;
			}
		}
	}


	//---  SSE2  ---
	if (flg & 0x4000000) {
		ci.bSSE2 = true;

		// OS support check
		__try {
			__asm	xorpd xmm0, xmm0
		}

		__except (EXCEPTION_EXECUTE_HANDLER) {
			if (_exception_code() == STATUS_ILLEGAL_INSTRUCTION) {
				ci.bSSE = false;
			}
		}
	}

	return  ci;
}
